#include <acknex.h>
#include <default.c>
#include <windows.h>

BMAP* maus = "maus.bmp";
BMAP* turm_bauen_1 = "turm_4.tga";
BMAP* turm_bauen_2 = "turm_5.tga";
BMAP* turm_bauen_3 = "turm_6.tga";
BMAP* turm_bauen_4 = "leben_2.tga";
BMAP* turm_bauen_5 = "geld_2.tga";
BMAP* turm_bauen_6 = "upgraden.tga";
BMAP* pfeil_links = "pfeil_links.tga";
BMAP* pfeil_rechts = "pfeil_rechts.tga";

FONT* comic = "Comic Sans MS#30b";

FONT* comic_2 = "Comic Sans MS#36";

FONT* comic_3 = "Comic Sans MS#70";

STRING* geld_string = "100";
STRING* leben_string = "20";
STRING* turm_anzeige = "";
STRING* turm_anzeige_2 = "";
STRING* tower = "";
STRING* menu_text_gehen = "";
STRING* quit_text = "";
STRING* einstellungen_string;
STRING* menu_eigenes_level = "Eig. Level";

var geld = 100;
var pos_turm[3];
var leben = 20;
var pos_feind[3];
var mouse_was[3];
var mouse_was_2[2];
var level_aktiv = 2;
var turme[10][10];
var video_modus[2];
var turm_art = 0;
var turm_aktiv;
var upgrade_jetzt = 0;
var level_gerade = 1;
var wellen;
var wellen_2;
var wartezeit;
var auswahl_turm = 0;
var sprache = 0;
var anfang = 0;
var einstellungen_n;
var einstellungen_1[4];
var einstellungen_2[4];
var level_extra;
var extra_level_geladen = 0;
var extra_level_pan;
var extra_level_pathfinding[9][9][3];
var extra_leben;
var extra_geld;

function pause();
function anpassen();
function language();
function auswahl_1();
function auswahl_2();
function auswahl_3();
function pos_mouse();
function menu_gehen();
function turm_event();
function level_back();
function enemy_event();
function upgraden_turm();
function aktualisieren();
function spiel_starten();
function spiel_beenden();
function create_level_2();
function aktualisieren_2();
function level_naechstes();
function toggle_bildschirm();
function extra_level_laden();
function teilen(wieviel);
function leben_weg(anzahl);
function weg_level(welches);
function create_level(nummmer);
function feinde_erschaffen(welchen_feind, zeit, anzahl, stufe);
function turm_erschaffen(welchen_feind, art, anzahl);

PANEL* mitte_1 =	{	bmap = "rahmen_mitte.tga";	pos_x = 600;	pos_y = 34;	layer = 1;	}
PANEL* mitte_2 =	{	bmap = "rahmen_mitte.tga";	pos_x = 600;	pos_y = 34;	layer = 1;	}
PANEL* mitte_3 =	{	bmap = "rahmen_mitte.tga";	pos_x = 600;	pos_y = 34;	layer = 1;	}
PANEL* mitte_4 =	{	bmap = "rahmen_mitte.tga";	pos_x = 600;	pos_y = 34;	layer = 1;	}
PANEL* mitte_5 =	{	bmap = "rahmen_mitte.tga";	pos_x = 600;	pos_y = 34;	layer = 1;	}
PANEL* mitte_6 =	{	bmap = "rahmen_mitte.tga";	pos_x = 600;	pos_y = 34;	layer = 1;	}

PANEL* pause_panel =
{
	bmap = "pause.tga";
	layer = 500;
	flags = OVERLAY;
}

PANEL* rahmen =
{
	bmap = "rahmen_kopf.tga";
	pos_x = 600;
	layer = 2;
	flags = OVERLAY;
}

PANEL* td_panel =
{
	bmap = "td.tga";
	layer = 600;
	flags = OVERLAY;
}

PANEL* rahmen_boden =
{
	bmap = "rahmen_boden.tga";
	pos_x = 600;
	pos_y = 480;
	layer = 2;
	flags = OVERLAY;
}

TEXT* gewonnen =
{
	font = comic_3;
	pos_x = 145;
	pos_y = 250;
	string("Congratulation!");
	layer = 6;
}

TEXT* verloren =
{
	font = comic_3;
	pos_x = 160;
	pos_y = 250;
	string("Game Over!");
	layer = 6;
}

TEXT* geld_text =
{
	layer = 6;
	pos_x = 717;
	pos_y = 140;
	font = comic;
	string(geld_string);
}

TEXT* leben_text =
{
	layer = 6;
	pos_x = 630;
	pos_y = 140;
	font = comic;
	string(leben_string);
}

TEXT* turm_text_2 =
{
	layer = 6;
	pos_x = 613;
	pos_y = 170;
	font = comic;
	string(tower);
}

TEXT* turm_text =
{
	layer = 6;
	pos_x = 613;
	pos_y = 265;
	font = comic;
	string(turm_anzeige);
}

TEXT* upgrade_text =
{
	layer = 8;
	pos_x = 650;
	pos_y = 460;
	font = comic_2;
	string("Upgrade");
}

TEXT* menu_text =
{
	layer = 6;
	pos_x = 650;
	pos_y = 530;
	font = comic_2;
	string(quit_text);
}

TEXT* menu_text_2 =
{
	layer = 6;
	pos_x = 650;
	pos_y = 320;
	font = comic_2;
	string("Start");
}

TEXT* menu_text_3 =
{
	layer = 6;
	pos_x = 650;
	pos_y = 530;
	font = comic_2;
	string(menu_text_gehen);
}

TEXT* menu_text_4 =
{
	layer = 6;
	pos_x = 620;
	pos_y = 390;
	font = comic_2;
	string("Level:");
}

TEXT* menu_text_6 =
{
	layer = 6;
	pos_x = 620;
	pos_y = 390;
	font = comic_2;
	string(menu_eigenes_level);
}

PANEL* menu =
{
	button = 0, 0, turm_bauen_6, turm_bauen_6, turm_bauen_6, spiel_starten(), NULL, NULL;
	flags = OVERLAY;
	layer = 5;
}

PANEL* menu_3 =
{
	button = 0, 0, pfeil_links, pfeil_links, pfeil_links, level_back(), NULL, NULL;
	flags = OVERLAY;
	layer = 5;
}

PANEL* menu_4 =
{
	button = 0, 0, pfeil_rechts, pfeil_rechts, pfeil_rechts, level_naechstes(), NULL, NULL;
	flags = OVERLAY;
	layer = 5;
}

PANEL* menu_5 =
{
	button = 0, 0, turm_bauen_6, turm_bauen_6, turm_bauen_6, spiel_beenden(), NULL, NULL;
	flags = OVERLAY;
	layer = 5;
}

PANEL* menu_6 =
{
	button = 0, 0, turm_bauen_6, turm_bauen_6, turm_bauen_6, extra_level_laden(), NULL, NULL;
	flags = OVERLAY;
	layer = 5;
}

PANEL* menu_2 =
{
	button = 0, 0, turm_bauen_6, turm_bauen_6, turm_bauen_6, menu_gehen(), NULL, NULL;
	flags = OVERLAY;
	layer = 5;
}

PANEL* turme_panels =
{
	button = 0, 200, turm_bauen_1, turm_bauen_1, turm_bauen_1, auswahl_1(), NULL, NULL;
	flags = OVERLAY;
	layer = 7;
}

PANEL* turme_panels_2 =
{
	button = 0, 200, turm_bauen_2, turm_bauen_2, turm_bauen_2, auswahl_2(), NULL, NULL;
	flags = OVERLAY;
	layer = 7;
}

PANEL* turme_panels_3 =
{
	button = 0, 200, turm_bauen_3, turm_bauen_3, turm_bauen_3, auswahl_3(), NULL, NULL;
	flags = OVERLAY;
	layer = 7;
}

PANEL* turme_panels_4 =
{
	button = 0, 80, turm_bauen_4, turm_bauen_4, turm_bauen_4, NULL, NULL, NULL;
	flags = OVERLAY;
	layer = 7;
}

PANEL* turme_panels_5 =
{
	button = 0, 80, turm_bauen_5, turm_bauen_5, turm_bauen_5, NULL, NULL, NULL;
	flags = OVERLAY;
	layer = 7;
}

PANEL* upgraden =
{
	button = 0, 0, turm_bauen_6, turm_bauen_6, turm_bauen_6, upgraden_turm(), NULL, NULL;
	flags = OVERLAY;
	layer = 7;
}

action block()
{
	wait(1);
	while((level_aktiv == 1) || (level_aktiv == 2))
	{
		wait(5);
	}
	ent_remove(me);
	wait(2);
	return;
}

action pfeil()
{
	set(me, PASSABLE);
	reset(me, VISIBLE);
	wait(2);
	my.skill1 = 0;
	my.x -= 10;
	my.y += 10;
	you = ptr_for_handle(my.skill2);
	if(you != NULL)
	{
		set(me, VISIBLE);
		while((my.skill1 != 1) && (you != NULL))
		{
			my.skill3 = your.x - my.x;
			my.skill4 = your.y - my.y;
			vec_to_angle(my.pan, vector(my.skill3, my.skill4, 32));
			my.pan += 180;
			my.tilt = 0;
			my.roll = 0;
			c_move(me, vector(((-28)) * time_step, 0, 0), nullvector, IGNORE_PASSABLE);
			my.skill5 = vec_dist(my.x, vector(your.x, your.y, my.z));
			if(my.skill5 <= 20)
			{
				your.skill73 -= my.skill6;
				my.skill1 = 1;
			}
			if(you == NULL)
			{
				ent_remove(me);
				wait(2);
				return;
			}
			wait(1);
		}
	}
	ent_remove(me);
	wait(2);
	return;
}

action turm_1()
{
	reset(me, VISIBLE);
	set(me, PASSABLE);
	my.skill50 = 1;
	my.pan = 90;
	c_trace(my.x, vector(my.x, my.y, -8), IGNORE_ME);
	if(result != 0)	{	ent_remove(me); wait(2); return;	}
	my.skill1 = 0;
	my.z = 20;
	while(my.skill1 <= 40)
	{
		c_move(me, vector(0, 0, -1), nullvector, GLIDE);
		my.skill1 += 1;
	}
	if(my.z > -8)
	{
		ent_remove(me); wait(2); return;
	}
	set(me, VISIBLE);
	my.emask |= (ENABLE_DETECT | ENABLE_CLICK | ENABLE_TOUCH);
	my.event = turm_event;
	my.skill2 = 0;
	my.skill90 = ((my.x + 256 + 32 + 64) / 64) - 1;
	my.skill91 = ((my.y + 256 + 32 + 64) / 64) - 1;
	if(turme[my.skill90][my.skill91] == 0)	{	turme[my.skill90][my.skill91] = 1;	}	else	{	ent_remove(me); wait(2); return;	}
	geld -= 50;
	if(key_shift == 0)	{	turm_art = 0;	}
	vec_set(my.blue,vector(255,255,255));
	my.skill95 = 0;
	my.skill96 = 0;
	while(level_aktiv == 1)
	{
		if(my.skill2 == 0)
		{
			c_scan(my.x, nullvector, vector(360, 0, (my.skill17 * my.skill16 * 10) + 250), IGNORE_ME);
		}
		if(my.skill19 == 1)	{	my.ambient = 100;	}
	else	{	if(my.skill20 == 0)	{	my.ambient = 0;	}	}
		if(my.skill20 == 1)
		{
			my.ambient = 100;
			if(geld >= 25)	{	set(upgraden, VISIBLE); set(upgrade_text, VISIBLE);	}
			else	{	reset(upgraden, VISIBLE); reset(upgrade_text, VISIBLE);	}
			if(upgrade_jetzt == 1)
			{
				my.skill95 = 0;
				reset(upgraden, VISIBLE); reset(upgrade_text, VISIBLE);
				while(my.skill95 < 100)
				{
					my.skill95++;
					if(turm_aktiv == 1)	{	my.skill20 = 0;	}
					aktualisieren();
					if(my.skill20 == 1)	{	reset(upgraden, VISIBLE); reset(upgrade_text, VISIBLE); my.ambient = 100;	}
					else	{	my.ambient = 0;	}
					wait(-0.05);
				}
				if(my.skill95 == 100)
				{
					upgrade_jetzt = 0; my.skill17 += 1; aktualisieren();
					if(level_aktiv != 1)	{	return;	}
					my.skill95 = 0;
				}
			}
			if(my.skill20 == 1)
			{
				my.skill70 = my.x + (my.skill17 * my.skill16 * 10) + 250;
				my.skill71 = my.x + teilen(0.5);
				my.skill72 = my.y + ((my.skill17 * my.skill16 * 10) + 250) * 0.5;
				my.skill73 = my.x + ((my.skill17 * my.skill16 * 10) + 250) * 0.5;
				my.skill74 = my.y + teilen(0.5);
				my.skill75 = my.y + (my.skill17 * my.skill16 * 10) + 250;
				my.skill76 = my.x - ((my.skill17 * my.skill16 * 10) + 250) * 0.5;
				my.skill77 = my.y + teilen(0.5);
				my.skill78 = my.x - teilen(0.5);
				my.skill79 = my.y + ((my.skill17 * my.skill16 * 10) + 250) * 0.5;
				my.skill80 = my.x - (my.skill17 * my.skill16 * 10) - 250;
				my.skill81 = my.x - teilen(0.5);
				my.skill82 = my.y - ((my.skill17 * my.skill16 * 10) + 250) * 0.5;
				my.skill83 = my.x - ((my.skill17 * my.skill16 * 10) + 250) * 0.5;
				my.skill84 = my.y - teilen(0.5);
				my.skill85 = my.y - (my.skill17 * my.skill16 * 10) - 250;
				my.skill86 = my.x + ((my.skill17 * my.skill16 * 10) + 250) * 0.5;
				my.skill87 = my.y - teilen(0.5);
				my.skill88 = my.x + teilen(0.5);
				my.skill89 = my.y - ((my.skill17 * my.skill16 * 10) + 250) * 0.5;
				if(my.skill70 >= 320)	{	draw_line3d(vector(350, my.y, 90), vector(0, 0, 255), 10);	}
				else	{	draw_line3d(vector(my.skill70, my.y, 90), vector(0, 0, 255), 10);	}
				if(my.skill71 >= 320)
				{	
					if(my.skill72 >= 256)	{	draw_line3d(vector(350, 286, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(350, my.skill72, 90), vector(0, 0, 255), 10);	}
				}
				else
				{
					if(my.skill72 >= 256)	{	draw_line3d(vector(my.skill71, 286, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(my.skill71, my.skill72, 90), vector(0, 0, 255), 10);	}
				}
				if(my.skill73 >= 320)
				{	
					if(my.skill74 >= 256)	{	draw_line3d(vector(350, 286, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(350, my.skill74, 90), vector(0, 0, 255), 10);	}
				}
				else
				{
					if(my.skill74 >= 256)	{	draw_line3d(vector(my.skill73, 286, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(my.skill73, my.skill74, 90), vector(0, 0, 255), 10);	}
				}
				if(my.skill75 >= 256)	{	draw_line3d(vector(my.x, 286, 90), vector(0, 0, 255), 10);	}
				else	{	draw_line3d(vector(my.x, my.skill75, 90), vector(0, 0, 255), 10);	}
				if(my.skill76 <= -256)
				{	
					if(my.skill77 >= 256)	{	draw_line3d(vector(-286, 286, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(-286, my.skill77, 90), vector(0, 0, 255), 10);	}
				}
				else
				{
					if(my.skill77 >= 256)	{	draw_line3d(vector(my.skill76, 286, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(my.skill76, my.skill77, 90), vector(0, 0, 255), 10);	}
				}
				if(my.skill78 <= -256)
				{	
					if(my.skill79 >= 256)	{	draw_line3d(vector(-286, 286, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(-286, my.skill79, 90), vector(0, 0, 255), 10);	}
				}
				else
				{
					if(my.skill79 >= 256)	{	draw_line3d(vector(my.skill78, 286, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(my.skill78, my.skill79, 90), vector(0, 0, 255), 10);	}
				}
				if(my.skill80 <= -256)	{	draw_line3d(vector(-286, my.y, 90), vector(0, 0, 255), 10);	}
				else	{	draw_line3d(vector(my.skill80, my.y, 90), vector(0, 0, 255), 10);	}
				if(my.skill81 <= -256)
				{	
					if(my.skill82 <= -320)	{	draw_line3d(vector(-286, -350, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(-286, my.skill82, 90), vector(0, 0, 255), 10);	}
				}
				else
				{
					if(my.skill82 <= -320)	{	draw_line3d(vector(my.skill81, -350, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(my.skill81, my.skill82, 90), vector(0, 0, 255), 10);	}
				}
				if(my.skill83 <= -256)
				{	
					if(my.skill84 <= -320)	{	draw_line3d(vector(-286, -350, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(-286, my.skill84, 90), vector(0, 0, 255), 10);	}
				}
				else
				{
					if(my.skill84 <= -320)	{	draw_line3d(vector(my.skill83, -350, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(my.skill83, my.skill84, 90), vector(0, 0, 255), 10);	}
				}
				if(my.skill85 <= -320)	{	draw_line3d(vector(my.x, -350, 90), vector(0, 0, 255), 10);	}
				else	{	draw_line3d(vector(my.x, my.skill85, 90), vector(0, 0, 255), 10);	}
				if(my.skill86 >= 320)
				{	
					if(my.skill87 <= -320)	{	draw_line3d(vector(350, -350, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(350, my.skill87, 90), vector(0, 0, 255), 10);	}
				}
				else
				{
					if(my.skill87 <= -320)	{	draw_line3d(vector(my.skill86, -350, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(my.skill86, my.skill87, 90), vector(0, 0, 255), 10);	}
				}
				if(my.skill88 >= 320)
				{	
					if(my.skill89 <= -320)	{	draw_line3d(vector(350, -350, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(350, my.skill89, 90), vector(0, 0, 255), 10);	}
				}
				else
				{
					if(my.skill89 <= -320)	{	draw_line3d(vector(my.skill88, -350, 90), vector(0, 0, 255), 10);	}
					else	{	draw_line3d(vector(my.skill88, my.skill89, 90), vector(0, 0, 255), 10);	}
				}
			}
		}
		if(mouse_right == 1)	{	my.skill20 = 0; auswahl_turm = 0;	}
		if(turm_aktiv == 1)	{	my.skill20 = 0;	}
		wait(1);
	}
	if(my.skill20 == 1)	{	auswahl_turm = 0;	}
	ent_remove(me);
	wait(2);
	return;
}

action enemy_1()
{
	wait(2);
	my.emask |= (ENABLE_DETECT | ENABLE_CLICK | ENABLE_TOUCH | ENABLE_SCAN);
	my.event = enemy_event;
	set(my, VISIBLE);
	set(my, PASSABLE);
	my.skill51 = 1;
	my.skill50 = 1;
	my.skill71 = 0;
	my.skill72 = level_gerade;
	my.skill73 = my.skill74 * (70 + my.skill90 * 20) + 330;
	if((auswahl_turm == 0) && (turm_art == 0))	{	anpassen();	}
	while((my.skill73 >= 1) && (my.skill71 >= 0) && (level_aktiv == 1))
	{
		if((my.skill90 != 7) && (my.skill90 != 8) && (my.skill90 != 9))
		{
			c_move(me, vector((7 + my.skill90) * time_step, 0, 0), nullvector, IGNORE_PASSABLE);
		}
		else
		{
			c_move(me, vector(7 * time_step, 0, 0), nullvector, IGNORE_PASSABLE);
		}
		weg_level(my.skill72);
		if(my.skill19 == 1)	{	my.ambient = 100;	}
	else	{	if(my.skill20 == 0)	{	my.ambient = 0;	}	}
		if(my.skill20 == 1)	{	my.ambient = 100; aktualisieren_2();	}
		if((mouse_right == 1) || (turm_aktiv == 1))	{	my.skill20 = 0;	}
		wait(1);
	}
	if(my.skill20 == 1)	{	anpassen(); auswahl_turm = 0;	}
	if((auswahl_turm == 0) && (turm_art == 0))	{	anpassen();	}
	if(my.skill71 == -1)	{	leben_weg(1);	}
	else {	geld += my.skill90;	}
	ent_remove(me); 
	wait(2);
	return;
}

function main()
{
	fps_max = 60;
	level_load("grund.wmb");
	wait(2);
	einstellungen_n = file_open_read("einstellungen.td");
	einstellungen_1[0] = file_var_read(einstellungen_n);
	einstellungen_1[1] = file_var_read(einstellungen_n);
	einstellungen_1[2] = file_var_read(einstellungen_n);
	einstellungen_1[3] = file_var_read(einstellungen_n);
	sprache = einstellungen_1[1];
	file_close(einstellungen_n);
	on_esc = spiel_beenden;
	if((einstellungen_1[0] != 1) && (einstellungen_1[0] != 2))
	{	printf("Der 1. Wert in einstellungen.td muss 1 (vollbild) oder 2 (Fenster) sein!"); sys_exit(NULL);	}
	if((einstellungen_1[1] != 1) && (einstellungen_1[1] != 0))
	{	printf("Der 2. Wert in einstellungen.td muss 0 (Englisch) oder 1 (Deutsch) sein!"); sys_exit(NULL);	}
	if((einstellungen_1[2] > (sys_metrics(0) - 50)) || (einstellungen_1[2] < 800))
	{	printf("Der 3. Wert in einstellungen.td muss kleiner als Bildschirmauflsung.Weite - 50 und grer als 799 sein!");
		sys_exit(NULL);	}
	if((einstellungen_1[3] > (sys_metrics(1) - 50)) || (einstellungen_1[3] < 600))
	{	printf("Der 4. Wert in einstellungen.td muss kleiner als Bildschirmauflsung.Hhe - 50 und grer als 599 sein!");
		sys_exit(NULL);	}
	
	if(einstellungen_1[0] == 1)	{	video_set(sys_metrics(0), sys_metrics(1), 32, 1);	}
	if(einstellungen_1[0] == 2)	{	video_set(einstellungen_1[2], einstellungen_1[3], 32, 2);	}
	var i_4;
	create_level_2();
	for(i_4=-100;i_4<0;i_4++)
	{
		if(anfang == 1)	{	i_4=0; 	}
		wait(-0.1);
	}
	vec_set(turm_text.blue, vector(182, 182, 182));
	vec_set(geld_text.blue, vector(182, 182, 182));
	vec_set(leben_text.blue, vector(182, 182, 182));
	vec_set(turm_text_2.blue, vector(182, 182, 182));
	mouse_range = 5000;
	gewonnen.pos_x = screen_size.x / 2 - 255;
	verloren.pos_x = screen_size.x / 2 - 240;
	leben_text.pos_x = screen_size.x - 170;
	turm_text.pos_x = screen_size.x - 187;
	turm_text_2.pos_x = screen_size.x - 187;
	geld_text.pos_x = screen_size.x - 83;
	upgrade_text.pos_x = screen_size.x - 150;
	menu_text.pos_x = screen_size.x - 150;
	menu_text_2.pos_x = screen_size.x - 150;
	menu_text_3.pos_x = screen_size.x - 150;
	menu_text_4.pos_x = screen_size.x - 180;
	menu_text_6.pos_x = screen_size.x - 150;
	menu.pos_x = screen_size.x - 180;
	menu_2.pos_x = screen_size.x - 180;
	menu_3.pos_x = screen_size.x - 180;
	menu_4.pos_x = screen_size.x - 90;
	menu_5.pos_x = screen_size.x - 180;
	menu_6.pos_x = screen_size.x - 180;
	turme_panels.pos_x = screen_size.x - 127;
	turme_panels_2.pos_x = screen_size.x - 194;
	turme_panels_3.pos_x = screen_size.x - 61;
	turme_panels_4.pos_x = screen_size.x - 174;
	turme_panels_5.pos_x = screen_size.x - 87;
	upgraden.pos_x = screen_size.x - 180;
	td_panel.pos_x = screen_size.x / 2 - 125;
	
	pause_panel.pos_x = screen_size.x / 2 - 250;
	pause_panel.pos_y = screen_size.y / 2 - 100;
	
	gewonnen.pos_y = screen_size.y / 2 - 50;
	verloren.pos_y = screen_size.y / 2 - 50;
	upgrade_text.pos_y = screen_size.y - 140;
	menu_text.pos_y = screen_size.y - 70;
	menu_text_2.pos_y = screen_size.y - 350;
	menu_text_6.pos_y = screen_size.y - 280;
	menu_text_3.pos_y = screen_size.y - 70;
	menu_text_4.pos_y = screen_size.y - 210;
	menu.pos_y = screen_size.y - 360;
	menu_2.pos_y = screen_size.y - 80;
	menu_3.pos_y = screen_size.y - 150;
	menu_4.pos_y = screen_size.y - 150;
	menu_5.pos_y = screen_size.y - 80;
	menu_6.pos_y = screen_size.y - 290;
	upgraden.pos_y = screen_size.y - 150;
	
	mitte_1.pos_x = screen_size.x - 200;
	mitte_2.pos_x = screen_size.x - 200;
	mitte_3.pos_x = screen_size.x - 200;
	mitte_4.pos_x = screen_size.x - 200;
	mitte_5.pos_x = screen_size.x - 200;
	mitte_6.pos_x = screen_size.x - 200;
	
	rahmen.pos_x = screen_size.x - 200;
	rahmen_boden.pos_x = screen_size.x - 200;
	
	rahmen.pos_y = 0;
	rahmen_boden.pos_y = screen_size.y - 120;
	
	mitte_1.pos_y = 34;
	mitte_2.pos_y = 34 + 240;
	
	
	td_panel.pos_y = screen_size.y / 2 - 125;
	
	if(screen_size.y >= (34 + 240 + 120 + 240 + 240))
	{
		mitte_3.pos_y = 34 + 240 + 240;
		if(screen_size.y >= (34 + 240 + 120 + 240 + 240 + 240))
		{
			mitte_4.pos_y = 34 + 240 + 240 + 240;
			if(screen_size.y >= (34 + 240 + 120 + 240 + 240 + 240 + 240))
			{
				mitte_5.pos_y = 34 + 240 + 240 + 240 + 240;
				if(screen_size.y >= (34 + 240 + 120 + 240 + 240 + 240 + 240 + 240))
				{
					mitte_6.pos_y = 34 + 240 + 240 + 240 + 240 + 240;
				}
				else
				{
					mitte_6.pos_y = screen_size.y - 120 - 240;
				}
			}
			else
			{
				mitte_5.pos_y = screen_size.y - 120 - 240;
				mitte_6.pos_y = 34;
			}
		}
		else
		{
			mitte_4.pos_y = 34;
			mitte_5.pos_y = 34;
			mitte_6.pos_y = screen_size.y - 120 - 240;
		}
	}
	else
	{
		mitte_3.pos_y = 34;
		mitte_4.pos_y = 34;
		mitte_5.pos_y = 34;
		mitte_6.pos_y = screen_size.y - 120 - 240;
	}
	if(sprache == 0)
	{
		str_cpy(menu_text_gehen, "Menu");
		str_cpy(tower, "Towers:");
		str_cpy(quit_text, "Quit");
		str_cpy(menu_eigenes_level, "Own Level");
	}
	if(sprache == 1)
	{
		str_cpy(menu_text_gehen, "Men");
		str_cpy(tower, "Trme:");
		str_cpy(quit_text, "Beenden");
		str_cpy(menu_eigenes_level, "Eig. Level");
	}
	set( mitte_1, VISIBLE | TRANSLUCENT);
	set( mitte_2, VISIBLE | TRANSLUCENT);
	set( mitte_3, VISIBLE | TRANSLUCENT);
	set( mitte_4, VISIBLE | TRANSLUCENT);
	set( mitte_5, VISIBLE | TRANSLUCENT);
	set( mitte_6, VISIBLE | TRANSLUCENT);
	set( rahmen, VISIBLE | TRANSLUCENT);
	set( rahmen_boden, VISIBLE | TRANSLUCENT);
	set( menu_text, VISIBLE | TRANSLUCENT);
	set( menu_text_2, VISIBLE | TRANSLUCENT);
	set( menu_text_4, VISIBLE | TRANSLUCENT);
	set( menu_text_6, VISIBLE | TRANSLUCENT);
	set( menu, VISIBLE | TRANSLUCENT);
	set( menu_3, VISIBLE | TRANSLUCENT);
	set( menu_4, VISIBLE | TRANSLUCENT);
	set( menu_5, VISIBLE | TRANSLUCENT);
	set( menu_6, VISIBLE | TRANSLUCENT);
	mitte_1.alpha = 0;
	mitte_2.alpha = 0;
	mitte_3.alpha = 0;
	mitte_4.alpha = 0;
	mitte_5.alpha = 0;
	mitte_6.alpha = 0;
	rahmen.alpha = 0;
	rahmen_boden.alpha = 0;
	menu_text.alpha = 0;
	menu_text_2.alpha = 0;
	menu_text_4.alpha = 0;
	menu.alpha = 0;
	menu_3.alpha = 0;
	menu_4.alpha = 0;
	menu_5.alpha = 0;
	menu_6.alpha = 0;
	if(anfang == 1)	{	set(td_panel, TRANSLUCENT);	}
	else	{	set(td_panel, VISIBLE | TRANSLUCENT);	}
	
	td_panel.alpha = 100;
	
	while(mitte_1.alpha != 100)
	{
		mitte_1.alpha++;
		mitte_2.alpha++;
		mitte_3.alpha++;
		mitte_4.alpha++;
		mitte_5.alpha++;
		mitte_6.alpha++;
		rahmen.alpha++;
		rahmen_boden.alpha++;
		menu_text.alpha++;
		menu_text_2.alpha++;
		menu_text_4.alpha++;
		menu_text_6.alpha++;
		menu.alpha++;
		menu_3.alpha++;
		menu_4.alpha++;
		menu_5.alpha++;
		menu_6.alpha++;
		if(anfang == 1)	{	mitte_1.alpha = 100;	}
		wait(3);
	}
	while(td_panel.alpha != 35)
	{
		td_panel.alpha--;
		if(anfang == 1)	{	td_panel.alpha = 35;	}
		wait(6);
	}
	mitte_1.alpha = 100;
	mitte_2.alpha = 100;
	mitte_3.alpha = 100;
	mitte_4.alpha = 100;
	mitte_5.alpha = 100;
	mitte_6.alpha = 100;
	rahmen.alpha = 100;
	rahmen_boden.alpha = 100;
	menu_text.alpha = 100;
	menu_text_2.alpha = 100;
	menu_text_4.alpha = 100;
	menu_text_6.alpha = 100;
	menu.alpha = 100;
	menu_3.alpha = 100;
	menu_4.alpha = 100;
	menu_5.alpha = 100;
	menu_6.alpha = 100;
	td_panel.alpha = 0;
	anfang = 1;
	video_modus[0] = sys_metrics(0);
	video_modus[1] = sys_metrics(1);
	mouse_map = maus;
	mouse_mode = 2;
	on_p = pause;
	on_f1 = language;
	on_f5 = toggle_bildschirm;
	on_f8 = extra_level_laden;
	on_2 = auswahl_1;
	on_1 = auswahl_2;
	on_3 = auswahl_3;
	on_cul = level_back;
	on_cur = level_naechstes;
	while(1)
	{
		mouse_pos.x = mouse_cursor.x;
		mouse_pos.y = mouse_cursor.y;
		if(mouse_left == 1)	{	pos_mouse();	}
		if(mouse_right == 1)
		{
			turm_art = 0;
			anpassen();
			reset(upgraden, VISIBLE);
			reset(upgrade_text, VISIBLE);
			turm_aktiv = 1;
			auswahl_turm = 0;
		}
		if(geld < 50)	{	turm_art = 0;	}
		if(leben <= 0)	{	menu_gehen(); set(verloren, VISIBLE); wait(-2); reset(verloren, VISIBLE); leben = 20;	}
		str_for_num(geld_string, integer(geld));
		str_for_num(leben_string, leben);
		if(wellen == 201)	{	menu_gehen(); set(gewonnen, VISIBLE); wait(-2); reset(gewonnen, VISIBLE); wellen = 1;	}
		if(level_aktiv != 1)	{	reset(upgraden, VISIBLE); reset(upgrade_text, VISIBLE);	}
		wait(1);
	}
}

function extra_level_laden()
{/*
	OPENFILENAME ofd;
	char buf[256];
	FillMemory(&ofd,sizeof(ofd),0);
	FillMemory(buf,256,0);
	ofd.Flags=OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST;
	ofd.lStructSize=sizeof(ofd);
	ofd.hwndOwner=hWnd;
	ofd.lpstrFilter = "Tower Defence Level (*.elvl)\0*.elvl\0\0";
	ofd.lpstrInitialDir = _chr(work_dir);
	ofd.lpstrFile=buf;
	ofd.nMaxFile=255; 
	ofd.lpstrTitle="Extra Level"; 
	if(GetOpenFileName(&ofd)) 
	{*/
		extra_level_geladen = 1;
		level_aktiv = 0;
		wait(6);
		level_aktiv = 2;
		var i_6;
		var j_6;
		var k_6 = -256;
		var l_6 = 256;
		var extra_file_n;
	//	extra_file_n = file_open_read(buf);
		extra_file_n = file_open_read("level.elvl");
		for(i_6=0;i_6<9;i_6++)
		{
			k_6 = -256;
			for(j_6=0;j_6<9;j_6++)
			{
				level_extra = file_var_read(extra_file_n);
				if(level_extra == 1)	{	ent_create("boden.wmb", vector(k_6, l_6, 0), block);	}
				k_6 += 64;
			}
			l_6 -= 64;
		}
		for(i_6=0;i_6<9;i_6++)
		{
			for(j_6=0;j_6<9;j_6++)
			{
				extra_level_pathfinding[i_6][j_6][0] = 0;
				extra_level_pathfinding[i_6][j_6][1] = 0;
				extra_level_pathfinding[i_6][j_6][2] = 0;
			}
		}
		l_6 = 256;
		for(i_6=0;i_6<9;i_6++)
		{
			k_6 = -256;
			for(j_6=0;j_6<9;j_6++)
			{
				level_extra = file_var_read(extra_file_n);
				if(level_extra == 5)	{	vec_set(pos_feind, vector(k_6 + 32, l_6 - 32, 32)); extra_level_pan = 0;	}
				if(level_extra == 6)	{	vec_set(pos_feind, vector(k_6 + 32, l_6 - 32, 32)); extra_level_pan = 90;	}
				if(level_extra == 7)	{	vec_set(pos_feind, vector(k_6 + 32, l_6 - 32, 32)); extra_level_pan = 180;	}
				if(level_extra == 8)	{	vec_set(pos_feind, vector(k_6 + 32, l_6 - 32, 32)); extra_level_pan = 270;	}
				if(level_extra == 9)	{	extra_level_pathfinding[i_6][j_6][0] = 1; extra_level_pathfinding[i_6][j_6][1] = -1;	}
				if(level_extra == 1)	{	extra_level_pathfinding[i_6][j_6][0] = 1; extra_level_pathfinding[i_6][j_6][1] = 0;	}
				if(level_extra == 2)	{	extra_level_pathfinding[i_6][j_6][0] = 1; extra_level_pathfinding[i_6][j_6][1] = 90;	}
				if(level_extra == 3)	{	extra_level_pathfinding[i_6][j_6][0] = 1; extra_level_pathfinding[i_6][j_6][1] = 180;	}
				if(level_extra == 4)	{	extra_level_pathfinding[i_6][j_6][0] = 1; extra_level_pathfinding[i_6][j_6][1] = 270;	}
				k_6 += 64;
			}
			l_6 -= 64;
		}
		for(i_6=0;i_6<9;i_6++)
		{
			for(j_6=0;j_6<9;j_6++)
			{
				level_extra = file_var_read(extra_file_n);
				if(level_extra != 0)	{	extra_level_pathfinding[i_6][j_6][2] = level_extra;	}
			}
		}
		extra_leben = file_var_read(extra_file_n);
		extra_geld = file_var_read(extra_file_n);
		file_close(extra_file_n);/*
	}
	else
	{
		return;
	}*/
}

function language()
{
	if(sprache == 0)	{	sprache = 1;	}
	else	{	sprache = 0; 	}
	if(sprache == 0)
	{
		str_cpy(menu_text_gehen, "Menu");
		str_cpy(tower, "Towers:");
		str_cpy(quit_text, "Quit");
		str_cpy(menu_eigenes_level, "Own Level");
	}
	if(sprache == 1)
	{
		str_cpy(menu_text_gehen, "Men");
		str_cpy(tower, "Trme:");
		str_cpy(quit_text, "Beenden");
		str_cpy(menu_eigenes_level, "Eig. Level");
	}
}

function pause()
{
	if(freeze_mode == 0)	{	freeze_mode = 2; set(pause_panel, VISIBLE);	}
	else	{	freeze_mode = 0; reset(pause_panel, VISIBLE);	}
}

function toggle_bildschirm()
{
	var geandert = 0;
	if((screen_size.x == video_modus[0]) && (geandert == 0))
	{
		geandert = 1;
		einstellungen_1[0] = 2;
		video_set(einstellungen_1[2], einstellungen_1[3], 32, 2);
	}
	if((screen_size.x != video_modus[0]) && (geandert == 0))
	{
		geandert = 1;
		einstellungen_1[0] = 1;
		video_set(video_modus[0], video_modus[1], 32, 1);
	}
	geandert = 0;
	
	pause_panel.pos_x = screen_size.x / 2 - 250;
	pause_panel.pos_y = screen_size.y / 2 - 100;
	
	gewonnen.pos_x = screen_size.x / 2 - 255;
	verloren.pos_x = screen_size.x / 2 - 240;
	leben_text.pos_x = screen_size.x - 170;
	turm_text.pos_x = screen_size.x - 187;
	turm_text_2.pos_x = screen_size.x - 187;
	geld_text.pos_x = screen_size.x - 83;
	upgrade_text.pos_x = screen_size.x - 150;
	menu_text.pos_x = screen_size.x - 150;
	menu_text_2.pos_x = screen_size.x - 150;
	menu_text_3.pos_x = screen_size.x - 150;
	menu_text_4.pos_x = screen_size.x - 180;
	menu_text_6.pos_x = screen_size.x - 150;
	menu.pos_x = screen_size.x - 180;
	menu_2.pos_x = screen_size.x - 180;
	menu_3.pos_x = screen_size.x - 180;
	menu_4.pos_x = screen_size.x - 90;
	menu_5.pos_x = screen_size.x - 180;
	menu_6.pos_x = screen_size.x - 180;
	turme_panels.pos_x = screen_size.x - 127;
	turme_panels_2.pos_x = screen_size.x - 194;
	turme_panels_3.pos_x = screen_size.x - 61;
	turme_panels_4.pos_x = screen_size.x - 174;
	turme_panels_5.pos_x = screen_size.x - 87;
	upgraden.pos_x = screen_size.x - 180;
	td_panel.pos_x = screen_size.x / 2 - 125;
	
	pause_panel.pos_x = screen_size.x / 2 - 250;
	pause_panel.pos_y = screen_size.y / 2 - 100;
	
	gewonnen.pos_y = screen_size.y / 2 - 50;
	verloren.pos_y = screen_size.y / 2 - 50;
	upgrade_text.pos_y = screen_size.y - 140;
	menu_text.pos_y = screen_size.y - 70;
	menu_text_2.pos_y = screen_size.y - 350;
	menu_text_6.pos_y = screen_size.y - 280;
	menu_text_3.pos_y = screen_size.y - 70;
	menu_text_4.pos_y = screen_size.y - 210;
	menu.pos_y = screen_size.y - 360;
	menu_2.pos_y = screen_size.y - 80;
	menu_3.pos_y = screen_size.y - 150;
	menu_4.pos_y = screen_size.y - 150;
	menu_5.pos_y = screen_size.y - 80;
	menu_6.pos_y = screen_size.y - 290;
	upgraden.pos_y = screen_size.y - 150;
	
	mitte_1.pos_x = screen_size.x - 200;
	mitte_2.pos_x = screen_size.x - 200;
	mitte_3.pos_x = screen_size.x - 200;
	mitte_4.pos_x = screen_size.x - 200;
	mitte_5.pos_x = screen_size.x - 200;
	mitte_6.pos_x = screen_size.x - 200;
	
	rahmen.pos_x = screen_size.x - 200;
	rahmen_boden.pos_x = screen_size.x - 200;
	
	rahmen.pos_y = 0;
	rahmen_boden.pos_y = screen_size.y - 120;
	
	mitte_1.pos_y = 34;
	mitte_2.pos_y = 34 + 240;
	if(screen_size.y >= (34 + 240 + 120 + 240 + 240))
	{
		mitte_3.pos_y = 34 + 240 + 240;
		if(screen_size.y >= (34 + 240 + 120 + 240 + 240 + 240))
		{
			mitte_4.pos_y = 34 + 240 + 240 + 240;
			if(screen_size.y >= (34 + 240 + 120 + 240 + 240 + 240 + 240))
			{
				mitte_5.pos_y = 34 + 240 + 240 + 240 + 240;
				if(screen_size.y >= (34 + 240 + 120 + 240 + 240 + 240 + 240 + 240))
				{
					mitte_6.pos_y = 34 + 240 + 240 + 240 + 240 + 240;
				}
				else
				{
					mitte_6.pos_y = screen_size.y - 120 - 240;
				}
			}
			else
			{
				mitte_5.pos_y = screen_size.y - 120 - 240;
				mitte_6.pos_y = 34;
			}
		}
		else
		{
			mitte_4.pos_y = screen_size.y - 120 - 240;
			mitte_5.pos_y = 34;
			mitte_6.pos_y = 34;
		}
	}
	else
	{
		mitte_3.pos_y = 34;
		mitte_4.pos_y = 34;
		mitte_5.pos_y = 34;
		mitte_6.pos_y = screen_size.y - 120 - 240;
	}
}

function teilen(wieviel)
{
	return(sqrt(pow((my.skill17 * my.skill16 * 10) + 250, 2) - pow(((my.skill17 * my.skill16 * 10) + 250) * wieviel, 2)));
}

function auswahl_1()
{
	turm_art = 1;
	if(sprache == 1)
	{
		str_cpy(turm_anzeige, "Turmeinstellungen:\n-Weite: 270\n-Schaden: 150\n-Pfeile: 1\n-Feuerrate: 0,5\n-Kosten: 50");
	}
	if(sprache == 0)
	{
		str_cpy(turm_anzeige, "Tower-Options:\n-Range: 270\n-Damage: 150\n-Arrows: 1\n-Firerate: 0,5\n-Costs: 50");
	}
}
function auswahl_2()
{
	turm_art = 2;
	if(sprache == 1)
	{
		str_cpy(turm_anzeige, "Turmeinstellungen:\n-Weite: 258\n-Schaden: 105\n-Pfeile: 2\n-Feuerrate: 0,7\n-Kosten: 50");
	}
	if(sprache == 0)
	{
		str_cpy(turm_anzeige, "Tower-Options:\n-Range: 258\n-Damage: 105\n-Arrows: 2\n-Firerate: 0,7\n-Costs: 50");
	}
}
function auswahl_3()
{
	turm_art = 3;
	if(sprache == 1)
	{
		str_cpy(turm_anzeige, "Turmeinstellungen:\n-Weite: 257\n-Schaden: 80\n-Pfeile: 5\n-Feuerrate: 0,9\n-Kosten: 100");
	}
	if(sprache == 0)
	{
		str_cpy(turm_anzeige, "Tower-Options:\n-Range: 257\n-Damage: 80\n-Arrows: 5\n-Firerate: 0,9\n-Costs: 100");
	}
}

function menu_gehen()
{
	set(menu, VISIBLE);
	set(menu_3, VISIBLE);
	set(menu_4, VISIBLE);
	set(menu_5, VISIBLE);
	set(menu_text, VISIBLE);
	set(menu_text_2, VISIBLE);
	set(menu_text_4, VISIBLE);
	set(menu_text_6, VISIBLE);
	set(menu_6, VISIBLE);
	reset( geld_text, VISIBLE);
	reset( leben_text, VISIBLE);
	reset( turm_text, VISIBLE);
	reset( turme_panels, VISIBLE);
	reset( turme_panels_2, VISIBLE);
	reset( turme_panels_3, VISIBLE);
	reset( turme_panels_4, VISIBLE);
	reset( turme_panels_5, VISIBLE);
	reset( menu_text_3, VISIBLE);
	reset( turm_text_2, VISIBLE);
	reset( menu_2, VISIBLE);
	level_aktiv = 2;
}

function anpassen()
{
	if(sprache == 1)
	{
		str_cpy(turm_anzeige, "Spieldaten:\n-Welle: ");
		str_for_num(turm_anzeige_2, wellen);
		str_cat(turm_anzeige, turm_anzeige_2);
	}
	if(sprache == 0)
	{
		str_cpy(turm_anzeige, "Information:\n-Wave: ");
		str_for_num(turm_anzeige_2, wellen);
		str_cat(turm_anzeige, turm_anzeige_2);
	}
}

function feinde_kommen()
{
	if(extra_level_geladen == 0)
	{
		if(level_gerade == 10)	{	vec_set(pos_feind, vector(-224, -32, 32));	}
		else	{	vec_set(pos_feind, vector(-224, 224, 32));	}
	}
	wartezeit = 1;
	var i_4;
	wellen = 1;
	wellen_2 = 1;
	while((level_aktiv == 1) && (wellen <= 200))
	{
		if(wellen != 1)	{	wellen_2 += 5;	}
		feinde_erschaffen(1, 1, 20, wellen_2);
		if(level_aktiv != 1)	{	return;	}
		for(i_4=0;i_4<384;i_4++)
		{
			wait(-0.0625);
			if(level_aktiv != 1)	{	return;	}
		}
		wellen++;
		wellen_2++;
		feinde_erschaffen(2, 0.9, 20, wellen_2);
		if(level_aktiv != 1)	{	return;	}
		for(i_4=0;i_4<352;i_4++)
		{
			wait(-0.0625);
			if(level_aktiv != 1)	{	return;	}
		}
		wellen++;
		wellen_2++;
		feinde_erschaffen(3, 0.8, 20, wellen_2);
		if(level_aktiv != 1)	{	return;	}
		for(i_4=0;i_4<320;i_4++)
		{
			wait(-0.0625);
			if(level_aktiv != 1)	{	return;	}
		}
		wellen++;
		wellen_2++;
		feinde_erschaffen(4, 0.7, 20, wellen_2);
		if(level_aktiv != 1)	{	return;	}
		for(i_4=0;i_4<288;i_4++)
		{
			wait(-0.0625);
			if(level_aktiv != 1)	{	return;	}
		}
		wellen++;
		wellen_2++;
		feinde_erschaffen(5, 0.6, 20, wellen_2);
		if(level_aktiv != 1)	{	return;	}
		for(i_4=0;i_4<256;i_4++)
		{
			wait(-0.0625);
			if(level_aktiv != 1)	{	return;	}
		}
		wellen++;
		wellen_2++;
		feinde_erschaffen(6, 0.5, 20, wellen_2);
		if(level_aktiv != 1)	{	return;	}
		for(i_4=0;i_4<224;i_4++)
		{
			wait(-0.0625);
			if(level_aktiv != 1)	{	return;	}
		}
		wellen++;
		feinde_erschaffen(7, 1, 5, wellen_2 + 30);
		for(i_4=0;i_4<260;i_4++)
		{
			wait(-0.0625);
			if(level_aktiv != 1)	{	return;	}
		}
		feinde_erschaffen(8, 1, 2, wellen_2 + 35);
		for(i_4=0;i_4<260;i_4++)
		{
			wait(-0.0625);
			if(level_aktiv != 1)	{	return;	}
		}
		feinde_erschaffen(9, 1, 1, wellen_2 + 40);
		for(i_4=0;i_4<260;i_4++)
		{
			wait(-0.0625);
			if(level_aktiv != 1)	{	return;	}
		}
	}
}

function level_naechstes()
{
	extra_level_geladen = 0;
	level_aktiv = 0;
	wait(6);
	level_gerade++;
	if(level_gerade == 11)	{	level_gerade = 1;	}
	wait(1);
	level_aktiv = 2;
	create_level(level_gerade);
}

function level_back()
{
	extra_level_geladen = 0;
	level_aktiv = 0;
	wait(6);
	level_gerade--;
	if(level_gerade == 0)	{	level_gerade = 10;	}
	wait(1);
	level_aktiv = 2;
	create_level(level_gerade);
}

function spiel_starten()
{
	geld = 100;
	if(level_gerade == 10)	{	geld = 1000;	}
	if(level_gerade == 9)	{	geld = 200;	}
	if(level_gerade == 8)	{	geld = 175;	}
	if(level_gerade == 7)	{	geld = 150;	}
	if(level_gerade == 6)	{	geld = 125;	}
	if(extra_level_geladen == 1)	{	geld = extra_geld;	}
	leben = 20;
	if(extra_level_geladen == 1)	{	leben = extra_leben;	}
	var i_4;
	var j_4;
	for(i_4=0;i_4<10;i_4++)
	{
		for(j_4=0;j_4<10;j_4++)
		{
			turme[i_4][j_4] = 0;
		}
	}
	reset(menu, VISIBLE);
	reset(menu_3, VISIBLE);
	reset(menu_4, VISIBLE);
	reset(menu_5, VISIBLE);
	reset(menu_text, VISIBLE);
	reset(menu_text_2, VISIBLE);
	reset(menu_text_4, VISIBLE);
	reset(menu_text_6, VISIBLE);
	reset(menu_6, VISIBLE);
	set( geld_text, VISIBLE);
	set( leben_text, VISIBLE);
	set( turm_text, VISIBLE);
	set( turme_panels, VISIBLE);
	set( turme_panels_2, VISIBLE);
	set( turme_panels_3, VISIBLE);
	set( turme_panels_4, VISIBLE);
	set( turme_panels_5, VISIBLE);
	set( menu_text_3, VISIBLE);
	set( turm_text_2, VISIBLE);
	set( menu_2, VISIBLE);
	level_aktiv = 1;
	feinde_kommen();
}

function spiel_beenden()
{
	if(anfang == 0)
	{
		anfang = 1;
		
	}
	else
	{
		einstellungen_n = file_open_write("einstellungen.td");
		file_var_write(einstellungen_n, einstellungen_1[0]);
		file_var_write(einstellungen_n, sprache);
		file_var_write(einstellungen_n, einstellungen_1[2]);
		file_var_write(einstellungen_n, einstellungen_1[3]);
		file_close(einstellungen_n);
		sys_exit(NULL);
		wait(2);
	}
}

function create_level_2()
{
	var i_3;
	var j_3;
	camera.x = 380;
	camera.y = -215;
	camera.z = 1037;
	camera.pan = 129;
	camera.tilt = -74;
	for(i_3=-256;i_3<=192;i_3+=64)
	{
		ent_create("boden.wmb", vector(i_3, 256, 0), block);
		if(anfang == 0)	{	wait(-0.2);	}
	}
	ent_create("boden.wmb", vector(192, 192, 0), block);
	if(anfang == 0)	{	wait(-0.2);	}
	for(i_3=192;i_3>=-256;i_3-=64)
	{
		ent_create("boden.wmb", vector(i_3, 128, 0), block);
		if(anfang == 0)	{	wait(-0.2);	}
	}
	ent_create("boden.wmb", vector(-256, 64, 0), block);
	if(anfang == 0)	{	wait(-0.2);	}
	for(i_3=-256;i_3<=192;i_3+=64)
	{
		ent_create("boden.wmb", vector(i_3, 0, 0), block);
		if(anfang == 0)	{	wait(-0.2);	}
	}
	ent_create("boden.wmb", vector(192, -64, 0), block);
	if(anfang == 0)	{	wait(-0.2);	}
	for(i_3=192;i_3>=-256;i_3-=64)
	{
		ent_create("boden.wmb", vector(i_3, -128, 0), block);
		if(anfang == 0)	{	wait(-0.2);	}
	}
	ent_create("boden.wmb", vector(-256, -192, 0), block);
	if(anfang == 0)	{	wait(-0.2);	}
	for(i_3=-256;i_3<=192;i_3+=64)
	{
		ent_create("boden.wmb", vector(i_3, -256, 0), block);
		if(anfang == 0)	{	wait(-0.2);	}
	}
}

function create_level(nummer)
{
	var i_3;
	var j_3;
	if(nummer == 1)
	{
		for(i_3=-256;i_3<=192;i_3+=64)
		{
			for(j_3=256;j_3>= -256;j_3-=128)
			{
				ent_create("boden.wmb", vector(i_3, j_3, 0), block);
			}
		}
		ent_create("boden.wmb", vector(192, 192, 0), block);
		ent_create("boden.wmb", vector(-256, 64, 0), block);
		ent_create("boden.wmb", vector(192, -64, 0), block);
		ent_create("boden.wmb", vector(-256, -192, 0), block);
	}
	if(nummer == 2)
	{
		for(i_3=-256;i_3<=192;i_3+=64)
		{
			ent_create("boden.wmb", vector(i_3, 256, 0), block);
		}
		for(i_3=192;i_3>=-192;i_3-=64)
		{
			ent_create("boden.wmb", vector(192, i_3, 0), block);
			if(i_3 != 192)
			{
				ent_create("boden.wmb", vector(64, i_3, 0), block);
				ent_create("boden.wmb", vector(-64, i_3, 0), block);
				ent_create("boden.wmb", vector(-192, i_3, 0), block);
			}
		}
		ent_create("boden.wmb", vector(128, -192, 0), block);
		ent_create("boden.wmb", vector(0, 128, 0), block);
		ent_create("boden.wmb", vector(-128, -192, 0), block);
		ent_create("boden.wmb", vector(-256, 128, 0), block);
	}
	if(nummer == 3)
	{
		for(i_3=-256;i_3<=192;i_3+=64)
		{
			ent_create("boden.wmb", vector(i_3, 256, 0), block);
			ent_create("boden.wmb", vector(i_3, -64, 0), block);
		}
		for(i_3=192;i_3>=64;i_3-=64)
		{
			ent_create("boden.wmb", vector(192, i_3, 0), block);
			ent_create("boden.wmb", vector(192, i_3-320, 0), block);
		}
		for(i_3=128;i_3>=0;i_3-=64)
		{
			ent_create("boden.wmb", vector(i_3, 64, 0), block);
			ent_create("boden.wmb", vector(i_3, -256, 0), block);
		}
		for(i_3=0;i_3>=-256;i_3-=64)
		{
			ent_create("boden.wmb", vector(i_3, 128, 0), block);
			ent_create("boden.wmb", vector(i_3, -192, 0), block);
		}
		for(i_3=64;i_3>=0;i_3-=64)
		{
			ent_create("boden.wmb", vector(-256, i_3, 0), block);
		}
	}
	if(nummer == 4)
	{
		for(i_3=-256;i_3<=192;i_3+=64)
		{
			ent_create("boden.wmb", vector(i_3, 256, 0), block);
			if(i_3 != -256)	{	ent_create("boden.wmb", vector(i_3, -192, 0), block);	}
			if((i_3 != -256) && (i_3 != 128) && (i_3 != 192))	{	ent_create("boden.wmb", vector(i_3, -64, 0), block);	}
			if((i_3 != -256) && (i_3 != 128) && (i_3 != -192) && (i_3 != 192))	{	ent_create("boden.wmb", vector(i_3, 128, 0), block);	}
			if((i_3 != -64) && (i_3 != 0) && (i_3 != 64) && (i_3 != 128) && (i_3 != 192))	{	ent_create("boden.wmb", vector(i_3, 64, 0), block);	}
		}
		for(i_3=192;i_3>=-128;i_3-=64)
		{
			ent_create("boden.wmb", vector(192, i_3, 0), block);
		}
		ent_create("boden.wmb", vector(-192, -128, 0), block);
		ent_create("boden.wmb", vector(64, 0, 0), block);
		ent_create("boden.wmb", vector(64, 64, 0), block);
	}
	if(nummer == 5)
	{
		for(i_3=-256;i_3<=-128;i_3+=64)
		{
			ent_create("boden.wmb", vector(i_3, 256, 0), block);
		}
		for(i_3=-192;i_3<=192;i_3+=64)
		{
			ent_create("boden.wmb", vector(i_3, -192, 0), block);
		}
		for(i_3=0;i_3<=192;i_3+=64)
		{
			ent_create("boden.wmb", vector(i_3, -64, 0), block);
			ent_create("boden.wmb", vector(i_3, 64, 0), block);
			ent_create("boden.wmb", vector(i_3, 192, 0), block);
		}
		for(i_3=128;i_3>=-192;i_3-=64)
		{
			ent_create("boden.wmb", vector(-192, i_3, 0), block);
		}
		ent_create("boden.wmb", vector(-128, 192, 0), block);
		ent_create("boden.wmb", vector(-128, 128, 0), block);
		ent_create("boden.wmb", vector(192, -128, 0), block);
		ent_create("boden.wmb", vector(192, 128, 0), block);
		ent_create("boden.wmb", vector(0, 0, 0), block);
		ent_create("boden.wmb", vector(0, 256, 0), block);
	}
	if(nummer == 6)
	{
		for(i_3=-256;i_3<=192;i_3+=64)
		{
			ent_create("boden.wmb", vector(i_3, 256, 0), block);
			if(i_3 != -256)	{	ent_create("boden.wmb", vector(i_3, -192, 0), block);	}
		}
		for(i_3=192;i_3>=-192;i_3-=64)
		{
			ent_create("boden.wmb", vector(192, i_3, 0), block);
		}
		for(i_3=-256;i_3<=64;i_3+=64)
		{
			ent_create("boden.wmb", vector(i_3, 128, 0), block);
			if(i_3 != -256)	{	ent_create("boden.wmb", vector(i_3, 0, 0), block);	}
		}
		ent_create("boden.wmb", vector(-192, -64, 0), block);
		ent_create("boden.wmb", vector(-192, -128, 0), block);
		ent_create("boden.wmb", vector(64, 64, 0), block);
	}
	if(nummer == 7)
	{
		for(i_3=-256;i_3<=256;i_3+=64)
		{
			if(i_3 != 256)	{	ent_create("boden.wmb", vector(i_3, 256, 0), block);	}
			if(i_3 != -256)	{	ent_create("boden.wmb", vector(i_3, -256, 0), block);	}
			if((i_3 != -256) && (i_3 != 256))	{	ent_create("boden.wmb", vector(i_3, 0, 0), block);	}
		}
		for(i_3=192;i_3>=64;i_3-=64)
		{
			ent_create("boden.wmb", vector(192, i_3, 0), block);
		}
		for(i_3=-64;i_3>=-192;i_3-=64)
		{
			ent_create("boden.wmb", vector(-192, i_3, 0), block);
		}
	}
	if(nummer == 8)
	{
		for(i_3=-256;i_3<=256;i_3+=64)
		{
			ent_create("boden.wmb", vector(i_3, 256, 0), block);
			ent_create("boden.wmb", vector(i_3, -256, 0), block);
		}
		for(i_3=192;i_3>=-192;i_3-=64)
		{
			ent_create("boden.wmb", vector(256, i_3, 0), block);
		}
	}
	if(nummer == 9)
	{
		for(i_3=-256;i_3<=56;i_3+=64)
		{
			ent_create("boden.wmb", vector(i_3, 256, 0), block);
			ent_create("boden.wmb", vector(i_3, -256, 0), block);
		}
		for(i_3=192;i_3>=-192;i_3-=64)
		{
			ent_create("boden.wmb", vector(0, i_3, 0), block);
		}
	}
	if(nummer == 10)
	{
		for(i_3=256;i_3>=-256;i_3-=64)
		{
			ent_create("boden.wmb", vector(i_3, 0, 0), block);
		}
	}
}

function upgraden_turm()
{
	upgrade_jetzt = 1;
	geld -= 25;
}

function aktualisieren()
{
	if(my.skill20 == 1)
	{
		if(sprache == 1)	{	str_cpy(turm_anzeige, "Turmeinstellungen:\n-Weite: ");	}
		if(sprache == 0)	{	str_cpy(turm_anzeige, "Tower-Options:\n-Range: ");	}
		str_for_num(turm_anzeige_2, integer((my.skill17 * my.skill16 * 10) + 250));
		str_cat(turm_anzeige, turm_anzeige_2);
		if(sprache == 1)	{	str_cat(turm_anzeige, "\n-Schaden: ");	}
		if(sprache == 0)	{	str_cat(turm_anzeige, "\n-Damage: ");	}
		if(my.skill18 == 1)	{	str_for_num(turm_anzeige_2, integer(100 + (my.skill17 * 50)));	}
		if(my.skill18 == 2)	{	str_for_num(turm_anzeige_2, integer(70 + (my.skill17 * 35)));	}
		if(my.skill18 == 3)	{	str_for_num(turm_anzeige_2, integer(40 + (my.skill17 * 40)));	}
		str_cat(turm_anzeige, turm_anzeige_2);
		if(sprache == 1)	{	str_cat(turm_anzeige, "\n-Pfeile: ");	}
		if(sprache == 0)	{	str_cat(turm_anzeige, "\n-Arrows: ");	}
		if(my.skill18 == 1)	{	str_cat(turm_anzeige, "1");	}
		if(my.skill18 == 2)	{	str_cat(turm_anzeige, "2");	}
		if(my.skill18 == 3)	{	str_cat(turm_anzeige, "5");	}
		if(sprache == 1)	{	str_cat(turm_anzeige, "\n-Feuerrate: ");	}
		if(sprache == 0)	{	str_cat(turm_anzeige, "\n-Firerate: ");	}
		if(my.skill18 == 1)	{	str_cat(turm_anzeige, "0,5");	}
		if(my.skill18 == 2)	{	str_cat(turm_anzeige, "0,7");	}
		if(my.skill18 == 3)	{	str_cat(turm_anzeige, "0,9");	}
		if(sprache == 1)	{	str_cat(turm_anzeige, "\n-Stufe: ");	}
		if(sprache == 0)	{	str_cat(turm_anzeige, "\n-Level: ");	}
		str_for_num(turm_anzeige_2, my.skill17);
		str_cat(turm_anzeige, turm_anzeige_2);
		if((my.skill95 != 0) && (my.skill95 != 100))
		{
			str_cat(turm_anzeige, " ");
			str_for_num(turm_anzeige_2, my.skill95);
			str_cat(turm_anzeige, turm_anzeige_2);
			str_cat(turm_anzeige, "%");
		}
	}
}

function aktualisieren_2()
{
	if(my.skill20 == 1)
	{
		reset(upgraden, VISIBLE);
		reset(upgrade_text, VISIBLE);
		if(sprache == 1)	{	str_cpy(turm_anzeige, "Gegner:\n-Geschw.: ");	}
		if(sprache == 0)	{	str_cpy(turm_anzeige, "Enemy:\n-Speed: ");	}
		if(my.skill90 == 1)	{	str_cat(turm_anzeige, "8");	}
		if(my.skill90 == 2)	{	str_cat(turm_anzeige, "9");	}
		if(my.skill90 == 3)	{	str_cat(turm_anzeige, "10");	}
		if(my.skill90 == 4)	{	str_cat(turm_anzeige, "11");	}
		if(my.skill90 == 5)	{	str_cat(turm_anzeige, "12");	}
		if(my.skill90 == 6)	{	str_cat(turm_anzeige, "13");	}
		if(my.skill90 == 7)	{	str_cat(turm_anzeige, "7");	}
		if(my.skill90 == 8)	{	str_cat(turm_anzeige, "7");	}
		if(my.skill90 == 9)	{	str_cat(turm_anzeige, "7");	}
		if(sprache == 1)	{	str_cat(turm_anzeige, "\n-Stabil.: ");	}
		if(sprache == 0)	{	str_cat(turm_anzeige, "\n-Stability: ");	}
		str_for_num(turm_anzeige_2, integer(my.skill73));
		str_cat(turm_anzeige, turm_anzeige_2);
		if(my.skill90 == 1)	{	str_cpy(turm_anzeige_2, "1");	}
		if(my.skill90 == 2)	{	str_cpy(turm_anzeige_2, "2");	}
		if(my.skill90 == 3)	{	str_cpy(turm_anzeige_2, "3");	}
		if(my.skill90 == 4)	{	str_cpy(turm_anzeige_2, "4");	}
		if(my.skill90 == 5)	{	str_cpy(turm_anzeige_2, "5");	}
		if(my.skill90 == 6)	{	str_cpy(turm_anzeige_2, "6");	}
		if(my.skill90 == 7)	{	str_cpy(turm_anzeige_2, "7");	}
		if(my.skill90 == 8)	{	str_cpy(turm_anzeige_2, "8");	}
		if(my.skill90 == 9)	{	str_cpy(turm_anzeige_2, "9");	}
		if(sprache == 1)	{	str_cat(turm_anzeige, "\n-Geld: ");	}
		if(sprache == 0)	{	str_cat(turm_anzeige, "\n-Money: ");	}
		str_cat(turm_anzeige, turm_anzeige_2);
		return;
	}
}

function feinde_erschaffen(welchen_feind, zeit, anzahl, stufe)
{
	var i_2;
	for(i_2=0;i_2<anzahl;i_2++)
	{
		if(stufe == 0)	{	stufe = 1;	}
		if(welchen_feind == 1)	{	you = ent_create("grun.mdl", pos_feind, enemy_1); you.skill90 = 1;	}
		if(welchen_feind == 2)	{	you = ent_create("rot.mdl", pos_feind, enemy_1); you.skill90 = 2;	}
		if(welchen_feind == 3)	{	you = ent_create("blau.mdl", pos_feind, enemy_1); you.skill90 = 3;	}
		if(welchen_feind == 4)	{	you = ent_create("grun_2.mdl", pos_feind, enemy_1); you.skill90 = 4;	}
		if(welchen_feind == 5)	{	you = ent_create("rot_2.mdl", pos_feind, enemy_1); you.skill90 = 5;	}
		if(welchen_feind == 6)	{	you = ent_create("blau_2.mdl", pos_feind, enemy_1); you.skill90 = 6;	}
		if(welchen_feind == 7)	{	you = ent_create("grun_3.mdl", pos_feind, enemy_1); you.skill90 = 7;	}
		if(welchen_feind == 8)	{	you = ent_create("rot_3.mdl", pos_feind, enemy_1); you.skill90 = 8;	}
		if(welchen_feind == 9)	{	you = ent_create("blau_3.mdl", pos_feind, enemy_1); you.skill90 = 9;	}
		you.skill74 = stufe;
		if(level_aktiv != 1)	{	return;	}
		if(extra_level_geladen == 1)
		{
			you.pan = extra_level_pan;
		}
		wait(-zeit);
	}
}

function turm_erschaffen(welchen_feind, art, anzahl)
{
	if(art != 0)
	{
		if(welchen_feind == 1)	{	you = ent_create("grau.mdl", pos_turm, turm_1);	art = 2;	}
		if(welchen_feind == 2)	{	you = ent_create("gelb.mdl", pos_turm, turm_1);	art = 0.85;	}
		if(welchen_feind == 3)	{	you = ent_create("grun_dunkel.mdl", pos_turm, turm_1);	art = 0.7;	}
		wait(1);
		your.skill17 = 1;
		your.skill18 = welchen_feind;
		your.skill16 = art;
	}
}

function leben_weg(anzahl)
{
	leben -= anzahl;
}

function pos_mouse()
{
	if(turm_art == 0)	{	return;	}
	mouse_was[0] = mouse_pos.x;
	mouse_was[1] = mouse_pos.y;
	mouse_was[2] = vec_length(camera.x);
	vec_for_screen(mouse_was, camera);
	if(mouse_was[0] <= -256)	{	return;	}
	if(mouse_was[0] >= 320)	{	return;	}
	if(mouse_was[1] <= -320)	{	return;	}
	if(mouse_was[1] >= 256)	{	return;	}
	var i;
	for(i=-320;i!=320;i+=64)
	{
	if(i != -320)	{	if((mouse_was[0] <= (i + 64)) && (mouse_was[0] > i))	{	mouse_was[0] = i + 32;	}	}
		if((mouse_was[1] >= i) && (mouse_was[1] < (i + 64)))	{	mouse_was[1] = i + 32;	}
	}
	mouse_was_2[0] = ((mouse_was[0] + 256 + 32 + 64) / 64) - 1;
	mouse_was_2[1] = ((mouse_was[1] + 256 + 32 + 64) / 64) - 1;
	mouse_was[2] = 9;
	vec_set(pos_turm, mouse_was);
	if(geld >= 50)	{	turm_erschaffen(turm_art, 1, 1);	}
	turm_aktiv = 1;
	wait(1);
	turm_aktiv = 0;
}

function weg_level(welches)
{
	if(extra_level_geladen == 0)
	{
	if(welches == 1)
	{
		if((my.x >= 224) && (my.skill71 == 0))	{	my.pan -= 90;	my.skill71 = 1;	}
		if((my.y <= 96) && (my.skill71 == 1))	{	my.pan -= 90;	my.skill71 = 2;	}
		if((my.x <= -224) && (my.skill71 == 2))	{	my.pan += 90;	my.skill71 = 3;	}
		if((my.y <= -32) && (my.skill71 == 3))	{	my.pan += 90;	my.skill71 = 4;	}
		if((my.x >= 224) && (my.skill71 == 4))	{	my.pan -= 90;	my.skill71 = 5;	}
		if((my.y <= -160) && (my.skill71 == 5))	{	my.pan -= 90;	my.skill71 = 6;	}
		if((my.x <= -224) && (my.skill71 == 6))	{	my.pan += 90;	my.skill71 = 7;	}
		if((my.y <= -288) && (my.skill71 == 7))	{	my.pan += 90;	my.skill71 = 8;	}
		if((my.x >= 244) && (my.skill71 == 8))	{	my.pan -= 90;	my.skill71 = -1;	}
	}
	if(welches == 2)
	{
		if((my.x >= 224) && (my.skill71 == 0))	{	my.pan -= 90;	my.skill71 = 1;	}
		if((my.y <= -224) && (my.skill71 == 1))	{	my.pan -= 90;	my.skill71 = 2;	}
		if((my.x <= 96) && (my.skill71 == 2))	{	my.pan -= 90;	my.skill71 = 3;	}
		if((my.y >= 96) && (my.skill71 == 3))	{	my.pan += 90;	my.skill71 = 4;	}
		if((my.x <= -32) && (my.skill71 == 4))	{	my.pan += 90;	my.skill71 = 5;	}
		if((my.y <= -224) && (my.skill71 == 5))	{	my.pan -= 90;	my.skill71 = 6;	}
		if((my.x <= -160) && (my.skill71 == 6))	{	my.pan -= 90;	my.skill71 = 7;	}
		if((my.y >= 96) && (my.skill71 == 7))	{	my.pan += 90;	my.skill71 = 8;	}
		if((my.x <= -224) && (my.skill71 == 8))	{	my.pan -= 90;	my.skill71 = -1;	}
	}
	if(welches == 3)
	{
		if((my.x >= 224) && (my.skill71 == 0))	{	my.pan -= 90;	my.skill71 = 1;	}
		if((my.y <= 32) && (my.skill71 == 1))	{	my.pan -= 90;	my.skill71 = 2;	}
		if((my.x <= 32) && (my.skill71 == 2))	{	my.pan -= 90;	my.skill71 = 3;	}
		if((my.y >= 96) && (my.skill71 == 3))	{	my.pan += 90;	my.skill71 = 4;	}
		if((my.x <= -224) && (my.skill71 == 4))	{	my.pan += 90;	my.skill71 = 5;	}
		if((my.y <= -96) && (my.skill71 == 5))	{	my.pan += 90;	my.skill71 = 6;	}
		if((my.x >= 224) && (my.skill71 == 6))	{	my.pan -= 90;	my.skill71 = 7;	}
		if((my.y <= -288) && (my.skill71 == 7))	{	my.pan -= 90;	my.skill71 = 8;	}
		if((my.x <= 32) && (my.skill71 == 8))	{	my.pan -= 90;	my.skill71 = 9;	}
		if((my.y >= -224) && (my.skill71 == 9))	{	my.pan += 90;	my.skill71 = 10;	}
		if((my.x <= -224) && (my.skill71 == 10))	{	my.pan += 90;	my.skill71 = -1;	}
	}
	if(welches == 4)
	{
		if((my.x >= 224) && (my.skill71 == 0))	{	my.pan -= 90;	my.skill71 = 1;	}
		if((my.y <= -224) && (my.skill71 == 1))	{	my.pan -= 90;	my.skill71 = 2;	}
		if((my.x <= -160) && (my.skill71 == 2))	{	my.pan -= 90;	my.skill71 = 3;	}
		if((my.y >= -96) && (my.skill71 == 3))	{	my.pan -= 90;	my.skill71 = 4;	}
		if((my.x >= 96) && (my.skill71 == 4))	{	my.pan += 90;	my.skill71 = 5;	}
		if((my.y >= 96) && (my.skill71 == 5))	{	my.pan += 90;	my.skill71 = 6;	}
		if((my.x <= -96) && (my.skill71 == 6))	{	my.pan += 90;	my.skill71 = 7;	}
		if((my.y <= 32) && (my.skill71 == 7))	{	my.pan -= 90;	my.skill71 = 8;	}
		if((my.x <= -224) && (my.skill71 == 8))	{	my.pan -= 90;	my.skill71 = -1;	}
	}
	if(welches == 5)
	{
		if((my.x >= -96) && (my.skill71 == 0))	{	my.pan -= 90;	my.skill71 = 1;	}
		if((my.y <= 96) && (my.skill71 == 1))	{	my.pan -= 90;	my.skill71 = 2;	}
		if((my.x <= -160) && (my.skill71 == 2))	{	my.pan += 90;	my.skill71 = 3;	}
		if((my.y <= -224) && (my.skill71 == 3))	{	my.pan += 90;	my.skill71 = 4;	}
		if((my.x >= 224) && (my.skill71 == 4))	{	my.pan += 90;	my.skill71 = 5;	}
		if((my.y >= -96) && (my.skill71 == 5))	{	my.pan += 90;	my.skill71 = 6;	}
		if((my.x <= 32) && (my.skill71 == 6))	{	my.pan -= 90;	my.skill71 = 7;	}
		if((my.y >= 32) && (my.skill71 == 7))	{	my.pan -= 90;	my.skill71 = 8;	}
		if((my.x >= 224) && (my.skill71 == 8))	{	my.pan += 90;	my.skill71 = 9;	}
		if((my.y >= 160) && (my.skill71 == 9))	{	my.pan += 90;	my.skill71 = 10;	}
		if((my.x <= 32) && (my.skill71 == 10))	{	my.pan -= 90;	my.skill71 = 11;	}
		if((my.y >= 224) && (my.skill71 == 11))	{	my.pan += 90;	my.skill71 = -1;	}
	}
	if(welches == 6)
	{
		if((my.x >= 224) && (my.skill71 == 0))	{	my.pan -= 90;	my.skill71 = 1;	}
		if((my.y <= -224) && (my.skill71 == 1))	{	my.pan -= 90;	my.skill71 = 2;	}
		if((my.x <= -192) && (my.skill71 == 2))	{	my.pan -= 90;	my.skill71 = 3;	}
		if((my.y >= -32) && (my.skill71 == 3))	{	my.pan -= 90;	my.skill71 = 4;	}
		if((my.x >= 96) && (my.skill71 == 4))	{	my.pan += 90;	my.skill71 = 5;	}
		if((my.y >= 96) && (my.skill71 == 5))	{	my.pan += 90;	my.skill71 = 6;	}
		if((my.x <= -224) && (my.skill71 == 6))	{	my.pan -= 90;	my.skill71 = -1;	}
	}
	if(welches == 7)
	{
		if((my.x >= 224) && (my.skill71 == 0))	{	my.pan -= 90;	my.skill71 = 1;	}
		if((my.y <= -32) && (my.skill71 == 1))	{	my.pan -= 90;	my.skill71 = 2;	}
		if((my.x <= -160) && (my.skill71 == 2))	{	my.pan += 90;	my.skill71 = 3;	}
		if((my.y <= -288) && (my.skill71 == 3))	{	my.pan += 90;	my.skill71 = 4;	}
		if((my.x >= 288) && (my.skill71 == 4))	{	my.pan += 90;	my.skill71 = -1;	}
	}
	if(welches == 8)
	{
		if((my.x >= 288) && (my.skill71 == 0))	{	my.pan -= 90;	my.skill71 = 1;	}
		if((my.y <= -288) && (my.skill71 == 1))	{	my.pan -= 90;	my.skill71 = 2;	}
		if((my.x <= -224) && (my.skill71 == 2))	{	my.pan -= 90;	my.skill71 = -1;	}
	}
	if(welches == 9)
	{
		if((my.x >= 32) && (my.skill71 == 0))	{	my.pan -= 90;	my.skill71 = 1;	}
		if((my.y <= -288) && (my.skill71 == 1))	{	my.pan -= 90;	my.skill71 = 2;	}
		if((my.x <= -224) && (my.skill71 == 2))	{	my.pan -= 90;	my.skill71 = -1;	}
	}
	if(welches == 10)
	{
		if((my.x >= 288) && (my.skill71 == 0))	{	my.pan -= 90;	my.skill71 = -1;	}
	}
	}
	else
	{
		if(my.skill71 == 0)	{	my.skill71 = 1;	}
		if(my.pan >= 360)	{	my.pan -= 360;	}
		var i_7;
		var j_7;
		for(i_7=0;i_7<9;i_7++)
		{
			for(j_7=0;j_7<9;j_7++)
			{
				if((extra_level_pathfinding[i_7][j_7][0] == 1) && (extra_level_pathfinding[i_7][j_7][2] == my.skill71))
				{
					my.skill91 = 64 * (j_7 - 4) + 32;//x
					my.skill92 = 64 * (16 - i_7 - 12) - 32;//y
					my.skill93 = extra_level_pathfinding[i_7][j_7][2];
					if(my.pan == 0)
					{
						if((my.x >= my.skill91) && (my.skill71 == my.skill93))
						{
							my.pan += extra_level_pathfinding[i_7][j_7][1]; my.skill71++;
							if(extra_level_pathfinding[i_7][j_7][1] == -1)	{	my.skill71 = -1;	}
						}
					}
					if(my.pan == 90)
					{
						if((my.y >= my.skill92) && (my.skill71 == my.skill93))
						{
							my.pan += extra_level_pathfinding[i_7][j_7][1]; my.skill71++;
							if(extra_level_pathfinding[i_7][j_7][1] == -1)	{	my.skill71 = -1;	}
						}
					}
					if(my.pan == 180)
					{
						if((my.x <= my.skill91) && (my.skill71 == my.skill93))
						{
							my.pan += extra_level_pathfinding[i_7][j_7][1]; my.skill71++;
							if(extra_level_pathfinding[i_7][j_7][1] == -1)	{	my.skill71 = -1;	}
						}
					}
					if(my.pan == 270)
					{
						if((my.y <= my.skill92) && (my.skill71 == my.skill93))
						{
							my.pan += extra_level_pathfinding[i_7][j_7][1]; my.skill71++;
							if(extra_level_pathfinding[i_7][j_7][1] == -1)	{	my.skill71 = -1;	}
						}
					}
				}
			}
		}
	}
}

function enemy_event()
{
	if(event_type == EVENT_CLICK)
	{
		auswahl_turm = 1;
		turm_aktiv = 1;
		wait(1);
		turm_aktiv = 0;
		my.skill20 = 1;
		reset(upgraden, VISIBLE);
		reset(upgrade_text, VISIBLE);
		if(sprache == 1)	{	str_cpy(turm_anzeige, "Gegner:\n-Geschw.: ");	}
		if(sprache == 0)	{	str_cpy(turm_anzeige, "Enemy:\n-Speed: ");	}
		if(my.skill90 == 1)	{	str_cat(turm_anzeige, "8");	}
		if(my.skill90 == 2)	{	str_cat(turm_anzeige, "9");	}
		if(my.skill90 == 3)	{	str_cat(turm_anzeige, "10");	}
		if(my.skill90 == 4)	{	str_cat(turm_anzeige, "11");	}
		if(my.skill90 == 5)	{	str_cat(turm_anzeige, "12");	}
		if(my.skill90 == 6)	{	str_cat(turm_anzeige, "13");	}
		if(sprache == 1)	{	str_cat(turm_anzeige, "\n-Stabil.: ");	}
		if(sprache == 0)	{	str_cat(turm_anzeige, "\n-Stability: ");	}
		str_for_num(turm_anzeige_2, integer(my.skill73));
		str_cat(turm_anzeige, turm_anzeige_2);
		if(my.skill90 == 1)	{	str_cpy(turm_anzeige_2, "1");	}
		if(my.skill90 == 2)	{	str_cpy(turm_anzeige_2, "2");	}
		if(my.skill90 == 3)	{	str_cpy(turm_anzeige_2, "3");	}
		if(my.skill90 == 4)	{	str_cpy(turm_anzeige_2, "4");	}
		if(my.skill90 == 5)	{	str_cpy(turm_anzeige_2, "5");	}
		if(my.skill90 == 6)	{	str_cpy(turm_anzeige_2, "6");	}
		if(sprache == 1)	{	str_cat(turm_anzeige, "\n-Geld: ");	}
		if(sprache == 0)	{	str_cat(turm_anzeige, "\n-Money: ");	}
		return;
	}
	if(event_type == EVENT_TOUCH)
	{
		if((turm_art == 1) || (turm_art == 2) || (turm_art == 3))	{	return;	}
		my.skill19 = 1;
		wait(-1);
		my.skill19 = 0;
		return;
	}
}

function turm_event()
{
	if(event_type == EVENT_TOUCH)
	{
		if((turm_art == 1) || (turm_art == 2) || (turm_art == 3))	{	return;	}
		my.skill19 = 1;
		wait(-1);
		my.skill19 = 0;
		return;
	}
	if(event_type == EVENT_CLICK)
	{
		turm_aktiv = 1;
		upgrade_jetzt = 0;
		wait(-0.1);
		turm_aktiv = 0;
		my.skill20 = 1;
		auswahl_turm = 1;
		if((turm_art == 1) || (turm_art == 2) || (turm_art == 3))	{	turm_art = 0;	}
		if(sprache == 1)	{	str_cpy(turm_anzeige, "Turmeinstellungen:\n-Weite: ");	}
		if(sprache == 0)	{	str_cpy(turm_anzeige, "Tower-Options:\n-Range: ");	}
		str_for_num(turm_anzeige_2, integer((my.skill17 * my.skill16 * 10) + 250));
		str_cat(turm_anzeige, turm_anzeige_2);
		if(sprache == 1)	{	str_cat(turm_anzeige, "\n-Schaden: ");	}
		if(sprache == 0)	{	str_cat(turm_anzeige, "\n-Damage: ");	}
		if(my.skill18 == 1)	{	str_for_num(turm_anzeige_2, integer(100 + (my.skill17 * 50)));	}
		if(my.skill18 == 2)	{	str_for_num(turm_anzeige_2, integer(70 + (my.skill17 * 35)));	}
		if(my.skill18 == 3)	{	str_for_num(turm_anzeige_2, integer(40 + (my.skill17 * 40)));	}
		str_cat(turm_anzeige, turm_anzeige_2);
		if(sprache == 1)	{	str_cat(turm_anzeige, "\n-Pfeile: ");	}
		if(sprache == 0)	{	str_cat(turm_anzeige, "\n-Arrows: ");	}
		if(my.skill18 == 1)	{	str_cat(turm_anzeige, "1");	}
		if(my.skill18 == 2)	{	str_cat(turm_anzeige, "2");	}
		if(my.skill18 == 3)	{	str_cat(turm_anzeige, "5");	}
		if(sprache == 1)	{	str_cat(turm_anzeige, "\n-Feuerrate: ");	}
		if(sprache == 0)	{	str_cat(turm_anzeige, "\n-Firerate: ");	}
		if(my.skill18 == 1)	{	str_cat(turm_anzeige, "0,5");	}
		if(my.skill18 == 2)	{	str_cat(turm_anzeige, "0,7");	}
		if(my.skill18 == 3)	{	str_cat(turm_anzeige, "0,9");	}
		if(sprache == 1)	{	str_cat(turm_anzeige, "\n-Stufe: ");	}
		if(sprache == 0)	{	str_cat(turm_anzeige, "\n-Level: ");	}
		str_for_num(turm_anzeige_2, my.skill17);
		str_cat(turm_anzeige, turm_anzeige_2);
		if((my.skill95 != 0) && (my.skill95 != 100))
		{
			str_cat(turm_anzeige, " ");
			str_for_num(turm_anzeige_2, my.skill95);
			str_cat(turm_anzeige, turm_anzeige_2);
			str_cat(turm_anzeige, "%");
		}
		return;
	}
	if((event_type == EVENT_DETECT) && (my.skill2 == 0) && (my.skill18 == 1) && (your.skill50 == 1))
	{
		if(your.skill51 == 1)	{	my.skill2 = 1;		}
		else	{	return;	}
		my.skill3 = your.x;
		my.skill4 = your.y;
		my.skill5 = handle(you);
		you = ent_create("grau_pfeil.mdl", my.x, pfeil);
		you.skill6 = 100 + (my.skill17 * 50);
		you.skill7 = my.skill17;
		you.skill8 = my.skill16;
		you.skill3 = my.skill3;
		you.skill4 = my.skill4;
		you.skill2 = my.skill5;
		wait(-0.5);
		my.skill2 = 0;
		return;
	}
	if((event_type == EVENT_DETECT) && (my.skill18 == 2) && (your.skill50 == 1) && (my.skill96 < 2))
	{
		if(your.skill51 != 1)	{	return;	}
		my.skill96++;
		my.skill2 = 1;
		my.skill3 = your.x;
		my.skill4 = your.y;
		my.skill5 = handle(you);
		you = ent_create("gelb_pfeil.mdl", my.x, pfeil);
		you.skill6 = 70 + (my.skill17 * 35);
		you.skill7 = my.skill17;
		you.skill8 = my.skill16;
		you.skill3 = my.skill3;
		you.skill4 = my.skill4;
		you.skill2 = my.skill5;
		wait(-0.7);
		my.skill96 = 0;
		my.skill2 = 0;
		return;
	}
	if((event_type == EVENT_DETECT) && (my.skill18 == 3) && (your.skill50 == 1) && (my.skill96 < 5))
	{
		if(your.skill51 != 1)	{	return;	}
		my.skill96++;
		my.skill2 = 1;
		my.skill3 = your.x;
		my.skill4 = your.y;
		my.skill5 = handle(you);
		you = ent_create("grun_dunkel_pfeil.mdl", my.x, pfeil);
		you.skill6 = 40 + (my.skill17 * 40);
		you.skill7 = my.skill17;
		you.skill8 = my.skill16;
		you.skill3 = my.skill3;
		you.skill4 = my.skill4;
		you.skill2 = my.skill5;
		wait(-0.9);
		my.skill96 = 0;
		my.skill2 = 0;
		return;
	}
}